<template>
  <div>
    <section class="primary darken-4 mb-3 white--text py-5">
      <v-container>
        <div class="d-flex flex-column align-start flex-sm-row align-center">
          <v-avatar
            color="accent"
            rounded
            size="130"
            class="mr-5"
          >
            <img
              alt="Avatar"
              :src="pro.avatar"
            >
          </v-avatar>
          <div class="py-3 text-center text-sm-left">
            <div class="text-h4">
              {{pro.firstName}} {{pro.lastName}}
            </div>
            <div class="text-h6">
              {{pro.job}}
            </div>
          </div>
        </div>
      </v-container>
    </section>
    <section>
      <v-container>
        <v-row justify="center">
          <v-col
            cols="12"
            md="7"
            lg="8"
            order="2"
            order-md="0"
          >
            <v-sheet elevation="0" class="pa-4 mb-5 w-100" v-if="pro.description">
              <div class="text-subtitle-1 pa-0 mb-3">
                <v-icon left>mdi-map-marker-outline</v-icon> Présentation
              </div>
              <div class="pl-9">
                {{pro.description}}
              </div>
            </v-sheet>

            <v-row align="stretch" class="mx-0 mb-5" v-for="(office, index) in pro.offices" :key="index">
              <v-col
                cols="12"
                sm="8"
                order="2"
                order-md="0"
                class="pa-0"
              >
                <v-sheet elevation="0" class="pa-4" height="100%" width="100%">
                  <div class="text-subtitle-1 pa-0 mb-3">
                    <v-icon left>mdi-map-marker-outline</v-icon> Accès cabinet {{index + 1}}
                  </div>
                  <div class="pl-9">
                    <p>
                      <router-link :to="{name: 'Office', params: { officeId: office.id }}">{{office.name}}</router-link><br>
                      {{office.address}}<br>
                      {{office.postalCode}} {{office.city}} {{office.country}}<br>
                    </p>
                    <p>
                      <v-icon>mdi-phone</v-icon> {{office.phoneNumber}}<br>
                      <v-icon>mdi-fax</v-icon> {{office.faxNumber}}<br>
                      <v-icon>mdi-email</v-icon> {{office.email}}
                    </p>
                  </div>
                </v-sheet>
              </v-col>
              <v-col
                cols="12"
                sm="4"
                order="2"
                order-md="0"
                class="pa-0"
              >
                <!--<v-img src="@/assets/images/pro_map.png" width="100%" height="100%"></v-img>-->
                
                  <iframe width="100%" height="250" frameborder="0" style="border:0"
                          :src="'https://maps.google.com/maps?hl=fr&q=' + office.address + ', ' + office.postalCode + ', ' + office.city + ', ' + office.country + '&ie=UTF8&z=13&output=embed'"
                          allowfullscreen>
                  </iframe>
              </v-col>
            </v-row>
          </v-col>
          <v-col
            cols="12"
            sm="8"
            md="5"
            lg="4"
            order="1"
          >
            <v-stepper
              v-model="stepper"
              vertical
              class="take-rdv"
            >
              <v-stepper-header class="align-center justify-center primary white--text">
                <v-icon color="white" left>mdi-calendar-range</v-icon> Prendre un rendez-vous
              </v-stepper-header>
              <div v-if="!!appointment.valid" class="pa-3">
                <v-alert
                  type="success"
                >
                  Votre rendez-vous est validé
                </v-alert>
                <p>
                  Date<br>
                  <b>{{moment(appointment.date).format('dddd D MMMM') | capitalize}} à {{appointment.slot}}</b>
                </p>
                <p>
                  Cabinet<br>
                  <b>{{ pro.offices.find(office => office.id == appointment.office).name }}</b>
                </p>
                <p>
                  Motif de la consultation<br>
                  <b>{{ cares.find(care => care.id == appointment.care).label }}</b>
                </p>
                <div>
                  <v-btn
                    color="primary"
                    elevation="0"
                    width="100%"
                    :to="{name: 'CustomerAppointments'}"
                  >
                    Voir mes rendez-vous
                  </v-btn>
                </div>
              </div>
              <div v-else>
                <v-stepper-step
                  :complete="stepper > 1"
                  step="1"
                  v-bind="{editable: !loadingAdd && appointment.hasOwnProperty('office')}"
                >
                  Choix du cabinet
                  <small v-if="appointment.office && pro.offices">{{ pro.offices.find(office => office.id == appointment.office).name }}</small>
                </v-stepper-step>

                <v-stepper-content step="1">
                  <v-sheet class="mx-5 mb-3">
                    <v-select
                      class="mt-1"
                      :items="pro.offices"
                      item-text="name"
                      item-value="id"
                      label="Choisir un cabinet"
                      v-model="appointment.office"
                      @change="setOffice"
                      hide-details
                      flat
                      outlined
                      solo
                      dense
                    ></v-select>
                  </v-sheet>
                </v-stepper-content>

                <v-divider></v-divider>

                <v-stepper-step
                  :complete="stepper > 2"
                  step="2"
                  v-bind="{editable: !loadingAdd && appointment.hasOwnProperty('slot') }"
                >
                  Date et heure du rendez-vous
                  <small v-if="appointment.slot">{{moment(appointment.date).format('dddd D MMMM') | capitalize}} à {{appointment.slot}}</small>
                </v-stepper-step>

                <v-stepper-content step="2">
                  <v-sheet class="d-flex justify-space-between">
                    <v-btn icon tile class="mx-1 my-2" :disabled="!availabilities.length" @click="previousAvailabilities">
                      <v-icon>mdi-chevron-left</v-icon>
                    </v-btn>
                    <div v-if="!availabilities.length">
                      <v-progress-circular
                        indeterminate
                        color="primary"
                      ></v-progress-circular>
                    </div>
                    <div v-for="(availability, index) in availabilities" :key="index">
                      <div class="text-center">
                        {{ moment(availability.date).format('dddd') | capitalize }}<br><b>{{ moment(availability.date).format('DD MMM') }}</b>
                      </div>
                      <div class="d-flex flex-column">
                        <v-btn v-for="(slot, index) in availability.slots" @click="setDate(availability.date, slot)" :key="index" elevation="0" class="mx-1 my-1">
                            {{ slot }}
                        </v-btn>
                        <div v-if="!availability.slots.length">
                          <v-btn elevation="0" outlined color="red" class="mx-1 my-1" disabled>
                            <v-icon>mdi-cancel</v-icon>
                          </v-btn>
                        </div>
                      </div>
                    </div>
                    <v-btn icon tile class="mx-1 my-2" :disabled="!availabilities.length" @click="nextAvailabilities">
                      <v-icon>mdi-chevron-right</v-icon>
                    </v-btn>
                  </v-sheet>
                </v-stepper-content>

                <v-divider></v-divider>

                <v-stepper-step
                  :complete="stepper > 3"
                  step="3"
                  v-bind="{editable: !loadingAdd && appointment.hasOwnProperty('care')}"
                >
                  Motif de consultation
                  <small v-if="appointment.care && cares">{{ cares.find(care => care.id == appointment.care).label }}</small>
                </v-stepper-step>

                <v-stepper-content step="3">
                  <v-sheet class="mx-5 mb-3">
                    <v-select
                      class="mt-1"
                      :items="cares"
                      item-text="label"
                      item-value="id"
                      label="Choisir un motif"
                      v-model="appointment.care"
                      @change="stepper = 4"
                      hide-details
                      flat
                      outlined
                      solo
                      dense
                    ></v-select>
                  </v-sheet>
                </v-stepper-content>

                <v-divider></v-divider>

                <v-stepper-step
                  :complete="pro.date"
                  step="4"
                  v-bind="{editable: !loadingAdd && appointment.hasOwnProperty('care')}"
                >
                Confirmation
                </v-stepper-step>

                <v-stepper-content step="4">
                  <v-sheet class="mx-5 mb-3">
                    <p v-if="appointment.office">
                      Vous y êtes presque!
                    </p>

                    <p>
                      Merci de <b>vérifier les informations indiquées ci-dessus</b> avant de valider votre rendez-vous.
                    </p>
                    
                    <v-btn
                      color="success"
                      :loading="loadingAdd"
                      :disabled="loadingAdd"
                      @click="validAppointment">
                      Valider le rendez-vous
                    </v-btn>
                  </v-sheet>
                </v-stepper-content>
              </div>
            </v-stepper>
          </v-col>
        </v-row>
      </v-container>
    </section>
  </div>
</template>

<script>
export default {
  name: 'Show',
  methods:{
    setOffice: function(officeId){
      this.appointment = {};
      this.appointment.office = officeId;
      this.stepper++;

      this.rangeAvailabilities.dateStart = this.moment();

      this.fetchAvailabilities();
      this.fetchCares();
    },
    nextAvailabilities(){
      this.rangeAvailabilities.dateStart = this.rangeAvailabilities.dateStart.add(this.rangeAvailabilities.dayLength, 'days');
      this.fetchAvailabilities();
    },
    previousAvailabilities(){
      this.rangeAvailabilities.dateStart = this.rangeAvailabilities.dateStart.subtract(this.rangeAvailabilities.dayLength, 'days');
      this.fetchAvailabilities();
    },
    fetchCares(){
      this.$apiRest.get('/cares?pro='+this.$route.params.id+'&office=' + this.appointment.office)
        .then((res) => {
          this.cares = res.data['hydra:member'];
          
          this.$apiGraphql.post('', {
              query: `
                query {
                  careTypes {id, label, description}
                }
              `
            }).then((res) => {
              this.cares = this.cares.map(care => { return {...care, label: res.data.data.careTypes.find(careType => careType.id == care.type).label}})
            })
        })
    },
    fetchAvailabilities(){

      this.availabilities = {};

      let dateStart = this.rangeAvailabilities.dateStart;
      let dateEnd = this.moment(dateStart).add(this.rangeAvailabilities.dayLength, 'days');

      Promise.all([
        this.$apiGraphql.post('', {
          query: `
              query {
                  availabilities (where: {
                      id_user: ${this.pro.id}
                      id_office: ${this.appointment.office}
                  }){day_number, hour_start}
              }
          `
        }), 
        this.$apiRest.get(`/appointments?care.pro=${this.pro.id}&date[before]=${dateEnd.format('YYYY-MM-DD')}&date[after]=${dateStart.format('YYYY-MM-DD')}`), 
        this.$apiGraphql.post('', {
          query: `
              query {
                unavailabilities (where: {
                  id_user: ${this.pro.id}
                  start_gte: "${dateStart.startOf('day').format()}",
                  stop_lte: "${dateEnd.endOf('day').format()}"
                }) {
                  id
                  start
                  stop
                }
              }
          `
        })
      ]).then((results) => { 
        let availabilities = results[0].data.data.availabilities;
        let appointments = results[1].data['hydra:member'];
        let unavailabilities = results[2].data.data.unavailabilities;

        let currentDate = this.moment(dateStart);
        let final = [];
        for (let i = 0; i < this.rangeAvailabilities.dayLength; i++) {
          let dayNumber = currentDate.isoWeekday();
          
          final.push({
            date: currentDate.format('YYYY-MM-DD'),
            slots: availabilities.reduce((acc, value) => { 
                if(value.day_number != dayNumber)
                  return acc;

                if(currentDate.startOf('day') < this.moment().startOf('day'))
                  return acc;

                let availabilityDate = currentDate.hours(value.hour_start.split(':')[0]).minutes(value.hour_start.split(':')[1]);

                if(appointments.filter((appointment) => this.moment(appointment.date).format() === availabilityDate.format()).length)
                  return acc;

                if(unavailabilities.filter((unavailability) => this.moment(unavailability.start).format() <= availabilityDate.format() && this.moment(unavailability.stop).format() > availabilityDate.format()).length)
                  return acc;

                acc.push(value.hour_start)

                return acc;
              }, [])
          });
          
          currentDate.add(1, 'days');
        }

        this.availabilities = final;
      })
    },
    setDate: function(date, slot){
      this.appointment.date = date;
      this.appointment.slot = slot;
      this.stepper++;
    },
    validAppointment(){
      this.loadingAdd = true

      this.$apiRest.post('/appointments', {
          date: this.moment(this.appointment.date + ' ' + this.appointment.slot.replace('h', ':')).format(),
          care: "/api/cares/" + this.appointment.care,
          client: "/api/users/" + this.$store.getters.user.id
        })
        .then(() => {
            this.appointment.valid = true;
            this.loadingAdd = false;
        });
    },
  },
  created() {
    this.$apiRest.get('/users/'+this.$route.params.id+'?roles=PRO')
      .then(res => {
          this.pro = res.data;

          if(this.$route.params.office){
            this.setOffice(this.$route.params.office);
          }
          if(this.$route.params.date && this.$route.params.slot){
            this.setDate(this.$route.params.date, this.$route.params.slot);
          }

          // Boucle pour recup sur prisma le nom du soin
      })
  },
  data() {
    return {
      loadingAdd: false,
      stepper: 1,
      appointment: {},
      pro: {},
      availabilities: [],
      cares: [],
      rangeAvailabilities: {
        dateStart: this.moment(),
        dayLength: 3,
      }
    }
  },
  filters: {
    capitalize: function (value) {
      if (!value) return ''
      value = value.toString()
      return value.charAt(0).toUpperCase() + value.slice(1)
    }
  }
}
</script>

<style scoped>
.v-stepper--vertical .v-stepper__step{
  padding:15px;
}
.v-stepper{
  padding:0;
}
.v-stepper__header{
  height:unset!important;
  padding:10px;
}
.v-stepper__content{
  border-left:0!important;
  margin:0!important;
  padding:0!important;
}
.take-rdv{
    margin-top: -57px;
}
</style>

